from moviepy.editor import VideoClip
from PIL import Image, ImageDraw, ImageColor, ImageFont
import numpy
import math

colors = ["#66c2a5", "#fc8d62", "#8da0cb", "#e78ac3", "#a6d854", "#ffd92f"]
background = "#2A2826"
white = "#E6E6E6"

number = "5"

w, h = 500, 500
antialias = 4
fps = 30
dur = 10

def draw_circle(draw, x, y, r):
    draw.ellipse([x - r, y - r, x + r, y + r], fill=white)

def make_frame(t):
    im = Image.new("RGB", (w * antialias, h * antialias), background)
    draw = ImageDraw.Draw(im)
    
    cx = w * antialias / 2
    cy = h * antialias / 2
    circle_r = 5 * antialias
    amount = 20
    #scale = w * antialias / 2 / (amount + 1)

    #draw.ellipse([cx - circle_r, cy - circle_r, cx + circle_r, cy + circle_r], fill=white)
    arr_pos = []

    for i in range(0, amount):
        r = w * antialias / 6.5
        ang1 = (t / dur) * math.pi * 2 + math.pi * 2 / amount * i
        
        cur_x1 = cx + math.cos(ang1) * r * (math.sin(ang1 * 2 + (t / dur) * math.pi * 2) + 1.5)
        cur_y1 = cy + math.sin(ang1) * r * (math.sin(ang1 * 2 + (t / dur) * math.pi * 2) + 1.5)

        ang2 = (t / dur) * math.pi * 2 + math.pi * 2 / amount * i #!!!

        cur_x2 = cx + math.cos(ang2) * r * (math.sin(ang2 * 2 - (t / dur) * math.pi * 2) + 2)
        cur_y2 = cy + math.sin(ang2) * r * (math.sin(ang2 * 2 - (t / dur) * math.pi * 2) + 2)

        draw_circle(draw, cur_x1, cur_y1, circle_r)
        draw_circle(draw, cur_x2, cur_y2, circle_r)
        draw.line([(cur_x1, cur_y1), (cur_x2, cur_y2)], fill=white, width=2 * antialias)

        #draw.ellipse([cur_x - circle_r, cur_y - circle_r, cur_x + circle_r, cur_y + circle_r], fill=colors[i % len(colors)])
                
    for i in range(len(colors)):
        for j in range(i, len(arr_pos), len(colors)):
            draw.line(arr_pos[j] + arr_pos[j + len(colors) if (j + len(colors) < len(arr_pos)) else i], fill=colors[i], width=2 * antialias)
    im = im.resize([w, h], Image.LANCZOS)

    if (t == 0):
        im.save("frame" + number + ".png")

    return numpy.asarray(im)

clip = VideoClip(make_frame, duration=dur)

clip.write_gif("img" + number + ".gif", fps=fps)