from moviepy.editor import VideoClip
from PIL import Image, ImageDraw, ImageColor, ImageFont
import numpy
import math

colors = ["#66c2a5", "#fc8d62", "#8da0cb", "#e78ac3", "#a6d854", "#ffd92f"]
background = "#2A2826"
white = "#E6E6E6"

w, h = 500, 500
antialias = 4
fps = 30
dur = 4

def make_frame(t):
    im = Image.new("RGB", (w * antialias, h * antialias), colors[0])
    
    real_time = t / dur

    circle_r = 30 * antialias

    if (real_time < 0.5):
        cur_x = w * antialias * (real_time * 2)
        cur_y = h * antialias * (real_time * 2)
    else:
        cur_x = w * antialias * (1 - (real_time - 0.5) * 2)
        cur_y = h * antialias * (1 - (real_time - 0.5) * 2)

    draw = ImageDraw.Draw(im)

    draw.ellipse([cur_x - circle_r, cur_y - circle_r, cur_x + circle_r, cur_y + circle_r], fill=colors[1])

    im = im.resize((w, h), Image.LANCZOS)

    return numpy.asarray(im)


clip = VideoClip(make_frame, duration=dur)
clip.write_gif("img1.gif", fps=fps)