from PIL import Image, ImageColor, ImageDraw

colors = ["#66c2a5", "#fc8d62", "#8da0cb", "#e78ac3", "#a6d854", "#ffd92f"]
background = "#2A2826"
white = "#E6E6E6"

w, h = 500, 500

# "RGB", "RGBA", "L"

im = Image.new("RGB", (w, h), background)

im.save("1.png")
im.save("1.jpg")
im.save("1.bmp")

#im.show()

for i in range(w):
    for j in range(h):
        im.putpixel((i, j), (123, 12, 90))
        im.putpixel((i, j), ImageColor.getrgb(white))
        t = im.getpixel((i, j))

#im.show()



draw = ImageDraw.Draw(im)

draw.ellipse([200, 300, 450, 500], fill=colors[0], outline=colors[1])
draw.rectangle([250, 350, 400, 450], fill=colors[2])
draw.line([250, 350, 400, 450], fill=colors[3], width=30)
im.save("2.png")



antialias = 4

im = Image.new("RGB", (w * antialias, h * antialias), background)
draw = ImageDraw.Draw(im)

draw.ellipse([w * antialias * 0.1, h * antialias * 0.1, w * antialias * 0.9, h * antialias * 0.9], fill=white)

im = im.resize((w, h), Image.LANCZOS)
im.save("3.png")



im = Image.new("RGB", (w, h), background)
draw = ImageDraw.Draw(im)

draw.ellipse([200, 300, 450, 500], fill=colors[0], outline=colors[1])
draw.rectangle([250, 350, 400, 450], fill=colors[2])
draw.line([250, 350, 400, 450], fill=colors[3], width=30)

mask = Image.new("L", im.size, "black")
mask_draw = ImageDraw.Draw(mask)

mask_draw.ellipse([0, 0, w, h], fill="white") # "white" = 255
mask_draw.ellipse([10, 10, w - 10, h - 10], fill="black") # "black" = 0
mask_draw.ellipse([100, 100, w - 100, h - 100], fill=127)

im.paste(colors[5], mask=mask)

im.save("4.png")



import math

def f(num):
    return 255 - num

im = Image.open("Talos.png")
im = Image.eval(im, f)

#im = im.rotate(60, resample=Image.BICUBIC, expand=1)

#im = im.transform(im.size, Image.PERSPECTIVE, coefs)

im.save("6.png")
